```
# This file is part of the dune-xt project:
#   https://github.com/dune-community/dune-xt
# Copyright 2009-2020 dune-xt developers and contributors. All rights reserved.
# License: Dual licensed as BSD 2-Clause License (http://opensource.org/licenses/BSD-2-Clause)
#      or  GPL-2.0+ (http://opensource.org/licenses/gpl-license)
#          with "runtime exception" (http://www.dune-project.org/license.html)
# Authors:
#   Felix Schindler (2013 - 2014, 2016 - 2017, 2019)
#   René Fritze     (2009, 2015, 2019)
```

[![Build Status](https://travis-ci.org/dune-community/dune-xt-common.svg?branch=master)](https://travis-ci.org/dune-community/dune-xt-common)

dune-xt-common is an eXTensions module for DUNE (http://www.dune-project.org),
which is often used together with [dune-xt-grid](https://github.com/dune-community/dune-xt),
[dune-xt-functions](https://github.com/dune-community/dune-xt) and
[dune-xt-la](https://github.com/dune-community/dune-xt) in the context of
the discretization module [dune-gdt](https://github.com/dune-community/dune-gdt).

There is a paper describing some of the concepts behind these extensions. While
already dated, most ideas still apply:

```
T. Leibner and R. Milk and F. Schindler: "Extending DUNE: The dune-xt modules"
Archive of Numerical Software, 5:193-216, 2017
https://www.doi.org/10.11588/ans.2017.1.27720
```

New users may best try out this module by using the git supermodule
[dune-xt-super](https://github.com/dune-community/dune-xt-super), experienced
DUNE users may go ahead.

Please see our [github page](https://github.com/dune-community/dune-xt)
for issue tracking and further information. If you want to start hacking, go
ahead and fork us on github and have a look at the
[CONTRIBUTING.md](https://github.com/dune-community/dune-xt/blob/master/CONTRIBUTING.md).
